#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xmu/WinUtil.h>


int main(int argc, char **argv){
    

	char *thenamearg;
	char thename[1024];
	thenamearg = argv[1];
	sprintf(thename , "%s" , thenamearg);
	int x;
	int y;
	x = atoi(argv[2]);
	y = atoi(argv[3]);

     Display *dpy;  
     int windowid=0;
     XWindowAttributes windowattr;


     dpy = XOpenDisplay(NULL);
     if (dpy == NULL){
         fprintf(stderr, "Can't open display\n");
         return;
     }


     int scr = DefaultScreen (dpy);
     Window w  = RootWindow (dpy, scr);
     Window       root_return, parent_return;
     Window      *children = NULL;
     Window   root = RootWindow (dpy, scr);
     Window  client;
     //Atom            winNormalAtom = XInternAtom (dpy, "_NET_WM_WINDOW_TYPE_NORMAL", False);
     unsigned int nchildren, i;

    Atom xa_prop_name;
    Atom xa_ret_type;
     int ret_format;
    unsigned long ret_nitems;
    unsigned long ret_bytes_after;
    unsigned char *ret_prop;

    char thestring[1024];
//    char *thestring;


    if (!XQueryTree (dpy, root, &root_return, &parent_return, &children, &nchildren)){
	/* XQueryTree failed. */
	if (children)
	    XFree ((void *)children);
	//return winNormalAtom;
        return;
    }

    //char *win_name;
    int c=0;
    for (i = 0;i < nchildren;i++){
//printf("%d\n" , i);
	client = XmuClientWindow (dpy, children[i]);
//if(client){
        //if (client != children[i] ){
             //printf("%x\n" , client);

          XGetWindowAttributes(dpy,client, &windowattr);
          //if(windowattr.map_state == 2){
             //XFetchName(dpy,client , &win_name);
             //printf("%x %s\n" , client , win_name);

	if(  XGetWindowProperty(dpy, client, XInternAtom(dpy,  "WM_CLASS",  False) , 0, 1024 ,  False , 
                         XInternAtom (dpy, "STRING", False), &xa_ret_type, &ret_format,     
                         &ret_nitems, &ret_bytes_after, &ret_prop) == Success ){

		if (ret_prop){
			sprintf(thestring , "%s" , ret_prop);


			if (! strcmp(thename , thestring)){
				//printf( "----%s\n" , ret_prop);
				windowid=client;
				break;
			}
		}

	}

//free(win_name);
c++;
          //}
	//}
//}
    }
    if (children)
	XFree ((void *)children);

	if(windowid >0){
	     XMoveWindow( dpy, windowid, x, y );
	     XFlush(dpy);
	}
	XCloseDisplay(dpy);


}
